﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using System.Windows.Data;

namespace _289938_TreeViewContainerBindings
{
	public partial class MainPage : UserControl
	{
		RadTreeViewItem unselectedItem;

		public MainPage()
		{
			InitializeComponent();

			this.treeView.ItemsSource = this.GenerateData();
		}

		private ObservableCollection<DataItem> GenerateData()
		{
			ObservableCollection<DataItem> result = new ObservableCollection<DataItem>();

			for (int i = 0; i < 2; i++)
			{
				DataItem item = new DataItem()
				{
					Name = String.Format("Item {0}", i),
					isSelectable = true
				};

				for (int j = 0; j < 2; j++)
				{
					DataItem child = new DataItem()
					{
						Name = String.Format("Item {0}.{1}", i, j),
						isSelectable = false
					};

					for (int k = 0; k < 2; k++)
					{
						child.Children.Add(new DataItem()
						{
							Name = String.Format("Item {0}.{1}.{2}", i, j, k),
							isSelectable = true
						});
					}
					item.Children.Add(child);
				}
				result.Add(item);
			}
			return result;
		}

		private void treeView_PreviewSelected(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			RadTreeViewItem item = e.Source as RadTreeViewItem;
			if (!(item.Item as DataItem).isSelectable)
			{
				e.Handled = true;
				treeView.SelectedItem = unselectedItem;
			}
		}

		private void treeView_PreviewUnselected(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			unselectedItem = e.Source as RadTreeViewItem;
		}
	}
}
